package com.lancoo.track.comprehensive.service.impl;

package ..deTemp.1729408215965;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.lancoo.track.common.core.common.exception.BaseException;
import com.lancoo.track.common.core.component.SchoolIDRequestContext;
import com.lancoo.track.common.core.constans.Constans;
import com.lancoo.track.common.core.entity.dto.BullyingDetailDTO;
import com.lancoo.track.common.core.entity.dto.DetailClassInfor;
import com.lancoo.track.common.core.entity.dto.StateDTO;
import com.lancoo.track.common.core.entity.dto.Student;
import com.lancoo.track.common.core.entity.dto.WeCharPushVO;
import com.lancoo.track.common.core.entity.dto.WebDeviceEntity;
import com.lancoo.track.common.core.entity.dto.WebGroupInfor;
import com.lancoo.track.common.core.entity.dto.WebUserInfo;
import com.lancoo.track.common.core.entity.middle.SchoolInfor;
import com.lancoo.track.common.core.enums.AbnormalStateEnum;
import com.lancoo.track.common.core.enums.ActionTypeEnum;
import com.lancoo.track.common.core.enums.AskforleaveTypeEnum;
import com.lancoo.track.common.core.enums.ResultStatus;
import com.lancoo.track.common.core.enums.StudentSchoolStateEnum;
import com.lancoo.track.common.core.enums.UserType;
import com.lancoo.track.common.core.utils.DateFormatUtil;
import com.lancoo.track.comprehensive.entity.dto.action.StuAbnormalActionAlarmQueue;
import com.lancoo.track.comprehensive.entity.dto.query.AbnormalPieDTO;
import com.lancoo.track.comprehensive.entity.dto.query.AbnormalStatisticDTO;
import com.lancoo.track.comprehensive.entity.po.CountUserSchool;
import com.lancoo.track.comprehensive.entity.po.SetDeviceDeployment;
import com.lancoo.track.comprehensive.entity.po.SetInfoSetting;
import com.lancoo.track.comprehensive.entity.po.SetNvrHost;
import com.lancoo.track.comprehensive.entity.po.SetTermInfo;
import com.lancoo.track.comprehensive.entity.po.SetUserImportant;
import com.lancoo.track.comprehensive.entity.po.SourceUserTrail;
import com.lancoo.track.comprehensive.entity.po.StuAbnormalActionAlarm;
import com.lancoo.track.comprehensive.entity.system.SystemParam;
import com.lancoo.track.comprehensive.entity.vo.action.ActionDataVO;
import com.lancoo.track.comprehensive.entity.vo.upgrade.AbnormalNumOfAreaStatisticVO;
import com.lancoo.track.comprehensive.entity.vo.upgrade.AbnormalPieVO;
import com.lancoo.track.comprehensive.entity.vo.upgrade.AbnormalStatisticVO;
import com.lancoo.track.comprehensive.entity.vo.upgrade.MsgInfoSettingVO;
import com.lancoo.track.comprehensive.entity.vo.upgrade.StuAbnormalActionAlarmByClassOrGradeVO;
import com.lancoo.track.comprehensive.entity.vo.upgrade.StuAbnormalActionAlarmVO;
import com.lancoo.track.comprehensive.mapper.SetDeviceDeploymentMapper;
import com.lancoo.track.comprehensive.mapper.SetInfoSettingMapper;
import com.lancoo.track.comprehensive.mapper.SetNvrHostMapper;
import com.lancoo.track.comprehensive.mapper.SetTermInfoMapper;
import com.lancoo.track.comprehensive.mapper.SetUserImportantMapper;
import com.lancoo.track.comprehensive.mapper.SourceUserTrailMapper;
import com.lancoo.track.comprehensive.mapper.StuAbnormalActionAlarmMapper;
import com.lancoo.track.comprehensive.redis.service.RedisService;
import com.lancoo.track.comprehensive.service.AbnormalManageService;
import com.lancoo.track.comprehensive.service.CountUserSchoolService;
import com.lancoo.track.comprehensive.service.PushDataService;
import com.lancoo.track.comprehensive.service.SetInfoSettingService;
import com.lancoo.track.comprehensive.task.area.AreaSchedual;
import com.lancoo.track.comprehensive.task.area.impl.AreaSchedualImpl;
import com.lancoo.track.comprehensive.third.entity.ThirdAreaDto;
import com.lancoo.track.comprehensive.third.service.ThirdService;
import com.lancoo.track.comprehensive.utils.DBUtils;
import com.lancoo.track.comprehensive.utils.ListUtils;
import com.lancoo.track.comprehensive.utils.ObjFillUtils;
import com.lancoo.track.comprehensive.utils.PageUtil;
import com.lancoo.track.comprehensive.utils.ResourceDownloadUtils;
import com.lancoo.track.comprehensive.utils.ServiceUtils;
import java.io.File;
import java.io.IOException;
import java.math.BigDecimal;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.attribute.BasicFileAttributes;
import java.nio.file.attribute.FileTime;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.time.Duration;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.Set;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.TimeUnit;
import java.util.function.Function;
import java.util.stream.Collectors;
import javax.annotation.Resource;
import org.redisson.Redisson;
import org.redisson.api.RLock;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.env.Environment;
import org.springframework.dao.DataAccessException;
import org.springframework.stereotype.Service;

@Service
public class AbnormalManageServiceImpl implements AbnormalManageService {
  private static final Logger logger = LoggerFactory.getLogger(com.lancoo.track.comprehensive.service.impl.AbnormalManageServiceImpl.class);
  
  @Autowired
  private Environment env;
  
  @Resource
  ThirdService thirdService;
  
  @Resource
  SetDeviceDeploymentMapper setDeviceDeploymentMapper;
  
  @Resource
  SetUserImportantMapper setUserImportantMapper;
  
  @Resource
  SetNvrHostMapper setNvrHostMapper;
  
  @Resource
  ServiceUtils serviceUtils;
  
  @Resource
  SourceUserTrailMapper sourceUserTrailMapper;
  
  @Resource
  SetInfoSettingService setInfoSettingService;
  
  @Resource
  SetInfoSettingMapper setInfoSettingMapper;
  
  @Resource
  RedisService redisUtil;
  
  @Resource
  AreaSchedual areaSchedual;
  
  @Resource
  ObjectMapper objectMapper;
  
  @Resource
  StuAbnormalActionAlarmMapper stuAbnormalActionAlarmMapper;
  
  @Resource
  AbnormalManageService abnormalManageService;
  
  @Resource
  AreaSchedualImpl areaSchedualImpl;
  
  @Resource
  Redisson redisson;
  
  @Resource
  CountUserSchoolService countUserSchoolService;
  
  @Resource
  PushDataService pushDataService;
  
  @Resource
  SetTermInfoMapper setTermInfoMapper;
  
  @Resource
  DBUtils dbUtils;
  
  @Resource
  ResourceDownloadUtils resourceDownloadUtils;
  
  public static ConcurrentLinkedQueue<ActionDataVO> qiaokeQueue = new ConcurrentLinkedQueue<>();
  
  public Map<String, SourceUserTrail> getDangerMediaData(List<StuAbnormalActionAlarm> stuAbnormalActionAlarmList) {
    LinkedHashMap<String, SourceUserTrail> result = Maps.newLinkedHashMap();
    LinkedHashMap<String, List<String>> trailIdListMap = Maps.newLinkedHashMap();
    if (CollectionUtils.isEmpty(stuAbnormalActionAlarmList))
      return result; 
    List<StuAbnormalActionAlarm> countUserTrailListAfterFilter = (List<StuAbnormalActionAlarm>)stuAbnormalActionAlarmList.stream().filter(obj -> StringUtils.isNotBlank(obj.getAlarmRelatePic())).collect(Collectors.toList());
    if (CollectionUtils.isEmpty(countUserTrailListAfterFilter))
      return result; 
    List<String> userTrailList = (List<String>)countUserTrailListAfterFilter.stream().map(StuAbnormalActionAlarm::getAlarmRelatePic).collect(Collectors.toList());
    userTrailList.stream().forEach(usertrailid -> {
          List<String> trailIds = Arrays.asList(usertrailid.split(","));
          if (CollectionUtils.isNotEmpty(trailIds))
            trailIds.stream().forEach(()); 
        });
    Set<String> tableDateSet = trailIdListMap.keySet();
    if (CollectionUtils.isNotEmpty(tableDateSet))
      tableDateSet.stream().forEach(tableDate -> {
            List<String> tableIds = (List<String>)trailIdListMap.get(tableDate);
            if (CollectionUtils.isNotEmpty(tableIds)) {
              DateTime yyyyMMdd = DateUtil.parse(tableDate, "yyyyMMdd");
              try {
                List<SourceUserTrail> sourceUserTrailList = this.sourceUserTrailMapper.getUserTrail(tableIds, yyyyMMdd);
                sourceUserTrailList.stream().forEach(());
              } catch (DataAccessException e) {
                logger.error("【getDangerMediaData1】-->数据库报错-->{}", (Object[])e.getStackTrace());
              } 
            } 
          }); 
    return result;
  }
  
  public Map<String, Object> getTimeSlotAbnormalByCampusId(String userId, Integer userType, String startTime, String endTime, String campusId, String type, Integer pageNum, Integer pageSize) {
    Timestamp startTime1 = Timestamp.valueOf(startTime);
    Timestamp endTime1 = Timestamp.valueOf(endTime);
    LinkedList<Integer> abnormalTypes = Lists.newLinkedList();
    if (StringUtils.isNotBlank(type)) {
      if ("-1".equals(type))
        return PageUtil.startPage(null, pageNum, pageSize); 
      String[] split = type.split(",");
      for (int i = 0; i < split.length; i++) {
        try {
          String s = split[i];
          Integer typeNum = Integer.valueOf(s);
          abnormalTypes.add(typeNum);
        } catch (Exception e) {
          logger.error("【getTimeSlotAbnormalByCampusId】-->type类型转换错误-->{}", type);
        } 
      } 
    } 
    List<ThirdAreaDto> allBuildingByCampusId = this.serviceUtils.getAllBuildingByCampusId(campusId);
    if (allBuildingByCampusId.size() == 1 && ((ThirdAreaDto)allBuildingByCampusId.get(0)).getBuildingId().intValue() == -1)
      return PageUtil.startPage(null, pageNum, pageSize); 
    List<String> buildingIds = (List<String>)allBuildingByCampusId.stream().map(obj -> {
          s = new String();
          return obj.getBuildingId() + "";
        }).collect(Collectors.toList());
    logger.info("【getTimeSlotAbnormalByCampusId】-->buildingIds-->{}", buildingIds);
    List<StuAbnormalActionAlarm> alarmsFromDB = Lists.newArrayList();
    int alarmsCount = 0;
    List<StuAbnormalActionAlarmVO> alarms = Lists.newArrayList();
    try {
      alarmsFromDB = this.stuAbnormalActionAlarmMapper.selectListByCondition(userId, userType, startTime1, endTime1, buildingIds, abnormalTypes, pageSize, Integer.valueOf((pageNum.intValue() - 1) * pageSize.intValue()));
      alarmsCount = this.stuAbnormalActionAlarmMapper.selectCountByCondition(userId, userType, startTime1, endTime1, buildingIds, abnormalTypes);
      String cameraUri = ObjFillUtils.getCalculateResourceAddress();
      List<StuAbnormalActionAlarm> abnormalActionAlarmListOfDangerList = (List<StuAbnormalActionAlarm>)alarmsFromDB.stream().filter(obj -> ActionTypeEnum.CODE20.code.equals(obj.getAlarmTypeId())).collect(Collectors.toList());
      Map<String, SourceUserTrail> dangerMediaDataMap = getDangerMediaData(abnormalActionAlarmListOfDangerList);
      alarms = (List<StuAbnormalActionAlarmVO>)alarmsFromDB.stream().map(obj -> {
            StuAbnormalActionAlarmVO stuAbnormalActionAlarmVO = new StuAbnormalActionAlarmVO();
            List<StuAbnormalActionAlarmVO.AbnormalMedia> abnormalMediaArrayList = Lists.newArrayList();
            BeanUtils.copyProperties(obj, stuAbnormalActionAlarmVO);
            if (ActionTypeEnum.CODE20.code.equals(obj.getAlarmTypeId()) && !"isDemoEnv".equals(this.env.getProperty("demoEnv.isDemoEnv").trim())) {
              String alarmRelSourceId = obj.getAlarmRelatePic();
              if (StringUtils.isNotBlank(alarmRelSourceId)) {
                List<String> abnormalIds = Arrays.asList(alarmRelSourceId.split(","));
                if (CollectionUtils.isNotEmpty(abnormalIds))
                  abnormalIds.stream().forEach(()); 
              } 
            } else {
              String alarmRelatePic = obj.getAlarmRelatePic();
              String alarmRelateMov = obj.getAlarmRelateMov();
              if (StringUtils.isNotBlank(alarmRelatePic)) {
                alarmRelatePic = this.serviceUtils.subLastNameToEnCode(alarmRelatePic);
                if (alarmRelatePic.endsWith(".wav")) {
                  stuAbnormalActionAlarmVO.setAlarmRelatePic(null);
                  stuAbnormalActionAlarmVO.setAlarmRelateAudio(ObjFillUtils.concatenateStaticResourceUrls(cameraUri, alarmRelatePic));
                  abnormalMediaArrayList.add(new StuAbnormalActionAlarmVO.AbnormalMedia(ObjFillUtils.concatenateStaticResourceUrls(cameraUri, alarmRelatePic), Integer.valueOf(3)));
                } else {
                  stuAbnormalActionAlarmVO.setAlarmRelatePic(ObjFillUtils.concatenateStaticResourceUrls(cameraUri, alarmRelatePic));
                  abnormalMediaArrayList.add(new StuAbnormalActionAlarmVO.AbnormalMedia(ObjFillUtils.concatenateStaticResourceUrls(cameraUri, alarmRelatePic), Integer.valueOf(1)));
                } 
              } 
              if (StringUtils.isNotBlank(alarmRelateMov)) {
                alarmRelateMov = this.serviceUtils.subLastNameToEnCode(alarmRelateMov);
                stuAbnormalActionAlarmVO.setAlarmRelateMov(ObjFillUtils.concatenateStaticResourceUrls(cameraUri, alarmRelateMov));
                abnormalMediaArrayList.add(new StuAbnormalActionAlarmVO.AbnormalMedia(ObjFillUtils.concatenateStaticResourceUrls(cameraUri, alarmRelateMov), Integer.valueOf(2)));
              } 
            } 
            stuAbnormalActionAlarmVO.setAlarmTime(DateUtil.format(obj.getAlarmTime(), "yyyy-MM-dd HH:mm:ss"));
            stuAbnormalActionAlarmVO.setAbnormalMediaList(abnormalMediaArrayList);
            if (StringUtils.isBlank(cameraUri)) {
              stuAbnormalActionAlarmVO.setAlarmRelatePic(null);
              stuAbnormalActionAlarmVO.setAlarmRelateMov(null);
              stuAbnormalActionAlarmVO.setAlarmRelateAudio(null);
              stuAbnormalActionAlarmVO.setAbnormalMediaList(Lists.newArrayList());
            } 
            return stuAbnormalActionAlarmVO;
          }).collect(Collectors.toList());
    } catch (DataAccessException e) {
      logger.error(e.getMessage());
      return PageUtil.startPage(null, pageNum, pageSize);
    } 
    logger.info("【getTimeSlotAbnormalByCampusId】-->alarms的记录数-->{}", Integer.valueOf(CollectionUtils.isEmpty(alarms) ? 0 : alarms.size()));
    List<StuAbnormalActionAlarmVO> result = (List<StuAbnormalActionAlarmVO>)alarms.stream().sorted(Comparator.comparing(StuAbnormalActionAlarmVO::getAlarmTime).reversed()).collect(Collectors.toList());
    dealAlarmRecord(result);
    return PageUtil.startPageBySQL(result, Integer.valueOf(alarmsCount), pageNum, pageSize);
  }
  
  public List<StuAbnormalActionAlarmVO> getTimeSlotAbnormalByCampusIdWithoutPage(String userId, Integer userType, String startTime, String endTime, String campusId) {
    Timestamp startTime1 = Timestamp.valueOf(startTime);
    Timestamp endTime1 = Timestamp.valueOf(endTime);
    List<ThirdAreaDto> allBuildingByCampusId = this.serviceUtils.getAllBuildingByCampusId(campusId);
    if (allBuildingByCampusId.size() == 1 && ((ThirdAreaDto)allBuildingByCampusId.get(0)).getBuildingId().intValue() == -1)
      return Lists.newArrayList(); 
    List<String> buildingIds = (List<String>)allBuildingByCampusId.stream().map(obj -> {
          s = new String();
          return obj.getBuildingId() + "";
        }).collect(Collectors.toList());
    logger.info("【getTimeSlotAbnormalByCampusIdWithoutPage】-->buildingIds-->{}", buildingIds);
    List<StuAbnormalActionAlarm> alarmsFromDB = Lists.newArrayList();
    List<StuAbnormalActionAlarmVO> alarms = Lists.newArrayList();
    try {
      alarmsFromDB = this.stuAbnormalActionAlarmMapper.selectListByCondition(userId, userType, startTime1, endTime1, buildingIds, null, null, null);
      alarms = (List<StuAbnormalActionAlarmVO>)alarmsFromDB.stream().map(obj -> {
            StuAbnormalActionAlarmVO stuAbnormalActionAlarmVO = new StuAbnormalActionAlarmVO();
            BeanUtils.copyProperties(obj, stuAbnormalActionAlarmVO);
            stuAbnormalActionAlarmVO.setAlarmTime(DateUtil.format(obj.getAlarmTime(), "yyyy-MM-dd HH:mm:ss"));
            return stuAbnormalActionAlarmVO;
          }).collect(Collectors.toList());
    } catch (DataAccessException e) {
      logger.error(e.getMessage());
      return alarms;
    } 
    logger.info("【getTimeSlotAbnormalByCampusIdWithoutPage】-->alarms的记录数-->{}", Integer.valueOf(CollectionUtils.isEmpty(alarms) ? 0 : alarms.size()));
    List<StuAbnormalActionAlarmVO> result = (List<StuAbnormalActionAlarmVO>)alarms.stream().sorted(Comparator.comparing(StuAbnormalActionAlarmVO::getAlarmTime).reversed()).collect(Collectors.toList());
    dealAlarmRecord(result);
    List<StuAbnormalActionAlarmVO> resultAfterSorted = Lists.newArrayList();
    Map<Integer, List<StuAbnormalActionAlarmVO>> collect = (Map<Integer, List<StuAbnormalActionAlarmVO>>)result.stream().collect(Collectors.groupingBy(StuAbnormalActionAlarmVO::getAlarmTypeId));
    collect.forEach((key, val) -> {
          List<StuAbnormalActionAlarmVO> valAfterSort = (List<StuAbnormalActionAlarmVO>)val.stream().sorted(Comparator.comparing(StuAbnormalActionAlarmVO::getAlarmTime).reversed()).collect(Collectors.toList());
          resultAfterSorted.addAll(valAfterSort);
        });
    return resultAfterSorted;
  }
  
  public void dealAlarmRecord(List<StuAbnormalActionAlarmVO> result1) {
    result1.stream().forEach(obj -> {
          String alarmDescription = obj.getAlarmDescription();
          if (StringUtils.isNotBlank(alarmDescription) && alarmDescription.contains("")) {
            String s = DateUtil.format(new Date(), "yyyy-MM-dd HH:mm:ss");
            int length = s.length() + "".length();
            String substring = alarmDescription.substring(length);
            obj.setAlarmDescription(substring);
          } 
          if (!ActionTypeEnum.CODE7.code.equals(obj.getAlarmTypeId()))
            obj.setRemark(""); 
        });
  }
  
  public StuAbnormalActionAlarmByClassOrGradeVO searchAlarmInforByGradeOrClass(String id, String startTime, String endTime, String campusId) {
    StuAbnormalActionAlarmByClassOrGradeVO stuAbnormalActionAlarmByClassOrGradeVO = new StuAbnormalActionAlarmByClassOrGradeVO();
    List<StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm> subStuAbnormalActionAlarmList = Lists.newLinkedList();
    StuAbnormalActionAlarmVO stuAbnormalActionAlarmVO = null;
    Timestamp startTime1 = Timestamp.valueOf(startTime);
    Timestamp endTime1 = Timestamp.valueOf(endTime);
    List<ThirdAreaDto> allBuildingByCampusId = this.serviceUtils.getAllBuildingByCampusId(campusId);
    if (allBuildingByCampusId.size() == 1 && ((ThirdAreaDto)allBuildingByCampusId.get(0)).getBuildingId().intValue() == -1)
      return stuAbnormalActionAlarmByClassOrGradeVO; 
    List<String> buildingIds = (List<String>)allBuildingByCampusId.stream().map(obj -> {
          s = new String();
          return obj.getBuildingId() + "";
        }).collect(Collectors.toList());
    logger.info("【searchAlarmInforByGradeOrClass】-->buildingIds-->{}", buildingIds);
    try {
      if (StringUtils.isEmpty(id)) {
        logger.info("【searchAlarmInforByGradeOrClass】-->查询年级异常");
        List<StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm> subStuAbnormalActionAlarmLinkedList = this.stuAbnormalActionAlarmMapper.selectListByAll(startTime1, endTime1, buildingIds);
        List<WebGroupInfor> webGroupInforList = this.serviceUtils.getGradeInforList();
        subStuAbnormalActionAlarmList = (List<StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm>)webGroupInforList.stream().map(gradeInfor -> {
              StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm subStuAbnormalActionAlarm = new StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm();
              StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm alarm1 = subStuAbnormalActionAlarmLinkedList.stream().filter(()).findAny().orElse(null);
              subStuAbnormalActionAlarm.setId(gradeInfor.getGroupId());
              subStuAbnormalActionAlarm.setName(gradeInfor.getGroupName());
              if (ObjectUtils.isNotEmpty(alarm1))
                subStuAbnormalActionAlarm.setNum(alarm1.getNum()); 
              return subStuAbnormalActionAlarm;
            }).collect(Collectors.toList());
      } else {
        logger.info("【searchAlarmInforByGradeOrClass】-->查询班级异常");
        List<StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm> subStuAbnormalActionAlarmLinkedList = this.stuAbnormalActionAlarmMapper.selectListByGradeId(id, startTime1, endTime1, buildingIds);
        List<DetailClassInfor> allClassInfor = this.serviceUtils.getAllClassInfor();
        List<DetailClassInfor> allClassByGradeId = (List<DetailClassInfor>)allClassInfor.stream().filter(obj -> id.equals(obj.getGradeID())).collect(Collectors.toList());
        subStuAbnormalActionAlarmList = (List<StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm>)allClassByGradeId.stream().map(classInfor -> {
              StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm subStuAbnormalActionAlarm = new StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm();
              StuAbnormalActionAlarmByClassOrGradeVO.SubStuAbnormalActionAlarm alarm1 = subStuAbnormalActionAlarmLinkedList.stream().filter(()).findAny().orElse(null);
              subStuAbnormalActionAlarm.setId(classInfor.getClassID());
              subStuAbnormalActionAlarm.setName(classInfor.getClassName());
              if (ObjectUtils.isNotEmpty(alarm1))
                subStuAbnormalActionAlarm.setNum(alarm1.getNum()); 
              return subStuAbnormalActionAlarm;
            }).collect(Collectors.toList());
      } 
      long today = DateUtil.parseDate(DateUtil.format(new Date(), "yyyy-MM-dd")).getTime();
      if (startTime1.getTime() >= today) {
        logger.info("【searchAlarmInforByGradeOrClass】-->查询范围是今日的，获取最新异常");
        StuAbnormalActionAlarm stuAbnormalActionAlarm = this.stuAbnormalActionAlarmMapper.selectLastRecord(buildingIds);
        if (ObjectUtils.isNotEmpty(stuAbnormalActionAlarm)) {
          stuAbnormalActionAlarmVO = new StuAbnormalActionAlarmVO();
          BeanUtils.copyProperties(stuAbnormalActionAlarm, stuAbnormalActionAlarmVO);
          stuAbnormalActionAlarmVO.setAlarmTime(DateUtil.format(stuAbnormalActionAlarm.getAlarmTime(), "yyyy-MM-dd HH:mm:ss"));
          ArrayList<StuAbnormalActionAlarmVO> stuAbnormalActionAlarmVOS = Lists.newArrayList();
          stuAbnormalActionAlarmVOS.add(stuAbnormalActionAlarmVO);
          dealAlarmRecord(stuAbnormalActionAlarmVOS);
        } 
      } 
    } catch (DataAccessException e) {
      logger.error(e.getMessage());
      return stuAbnormalActionAlarmByClassOrGradeVO;
    } 
    stuAbnormalActionAlarmByClassOrGradeVO.setCountAbnormalList(subStuAbnormalActionAlarmList);
    stuAbnormalActionAlarmByClassOrGradeVO.setLastRecord(stuAbnormalActionAlarmVO);
    return stuAbnormalActionAlarmByClassOrGradeVO;
  }
  
  public List<AbnormalPieVO> analyseAbnormalPie(Integer userType, String userId, String startTime, String endTime, String campusId) {
    String schoolID = SchoolIDRequestContext.getSchoolIDLocal();
    List<AbnormalPieVO> result = Lists.newArrayList();
    LinkedHashMap<String, AbnormalPieVO> resultMap = Maps.newLinkedHashMap();
    List<AbnormalPieDTO> abnormalPieDTOList = Lists.newArrayList();
    Timestamp startTime1 = Timestamp.valueOf(startTime);
    Timestamp endTime1 = Timestamp.valueOf(endTime);
    ActionTypeEnum[] values = ActionTypeEnum.values();
    for (ActionTypeEnum channelEnum : values) {
      if (ActionTypeEnum.CODE3.getCode().equals(channelEnum.getCode()) || ActionTypeEnum.CODE4
        .getCode().equals(channelEnum.getCode()) || ActionTypeEnum.CODE5
        .getCode().equals(channelEnum.getCode()) || ActionTypeEnum.CODE11
        .getCode().equals(channelEnum.getCode()) || ActionTypeEnum.CODE21
        .getCode().equals(channelEnum.getCode())) {
        AbnormalPieVO abnormalPieVO = new AbnormalPieVO();
        abnormalPieVO.setType(channelEnum.getCode().intValue());
        abnormalPieVO.setTarget(channelEnum.getMsg());
        abnormalPieVO.setTargetNum(0);
        abnormalPieVO.setTargetPercent("0%");
        result.add(abnormalPieVO);
        resultMap.put(channelEnum.getCode() + "", abnormalPieVO);
      } 
      if ((ActionTypeEnum.CODE20.getCode().equals(channelEnum.getCode()) || ActionTypeEnum.CODE22
        .getCode().equals(channelEnum.getCode())) && 
        "S-ZSDFSJSCZB".equals(schoolID)) {
        AbnormalPieVO abnormalPieVO = new AbnormalPieVO();
        abnormalPieVO.setType(channelEnum.getCode().intValue());
        abnormalPieVO.setTarget(channelEnum.getMsg());
        abnormalPieVO.setTargetNum(0);
        abnormalPieVO.setTargetPercent("0%");
        result.add(abnormalPieVO);
        resultMap.put(channelEnum.getCode() + "", abnormalPieVO);
      } 
    } 
    List<String> buildingIds = Lists.newArrayList();
    List<ThirdAreaDto> allBuildingByCampusId = this.serviceUtils.getAllBuildingByCampusId(campusId);
    if (allBuildingByCampusId.size() == 1 && ((ThirdAreaDto)allBuildingByCampusId.get(0)).getBuildingId().intValue() == -1)
      return result; 
    buildingIds = (List<String>)allBuildingByCampusId.stream().map(obj -> {
          s = new String();
          return obj.getBuildingId() + "";
        }).collect(Collectors.toList());
    logger.info("【analyseAbnormalPie】-->buildingIds-->{}", buildingIds);
    try {
      abnormalPieDTOList = this.stuAbnormalActionAlarmMapper.analyseAbnormalPie(userId, userType, startTime1, endTime1, buildingIds);
      logger.info("【analyseAbnormalPie】-->resultMap的记录数为{}，abnormalPieDTOList的记录数为{}", Integer.valueOf(resultMap.size()), Integer.valueOf(abnormalPieDTOList.size()));
      if (CollectionUtils.isNotEmpty(abnormalPieDTOList)) {
        int abnormalSum = abnormalPieDTOList.stream().mapToInt(AbnormalPieDTO::getTargetNum).sum();
        abnormalPieDTOList.stream().forEach(obj -> {
              AbnormalPieVO abnormalPieVO = new AbnormalPieVO();
              Integer type = obj.getType();
              String target = ActionTypeEnum.getNameByKey(type);
              Integer targetNum = obj.getTargetNum();
              String targetPercent = "0.00%";
              if (abnormalSum > 0)
                targetPercent = getPercentByNum(targetNum, Integer.valueOf(abnormalSum)); 
              abnormalPieVO.setType(type.intValue());
              abnormalPieVO.setTarget(target);
              abnormalPieVO.setTargetNum(targetNum.intValue());
              abnormalPieVO.setTargetPercent(targetPercent);
              resultMap.put(type + "", abnormalPieVO);
            });
        result = Lists.newArrayList(resultMap.values());
      } 
    } catch (DataAccessException e) {
      logger.error(e.getMessage());
      return result;
    } 
    logger.info("【analyseAbnormalPie】-->result的记录数-->{}", Integer.valueOf(CollectionUtils.isEmpty(result) ? 0 : result.size()));
    return result;
  }
  
  public void recoverData(String startTime, String endTime, String path) throws IOException {
    DateTime start = DateUtil.parse(startTime);
    DateTime end = DateUtil.parse(endTime);
    List<Date> everyDay = DateFormatUtil.getEveryDay((Date)start, (Date)end);
    QueryWrapper<SetDeviceDeployment> setDeviceDeploymentQueryWrapper = new QueryWrapper();
    ((QueryWrapper)setDeviceDeploymentQueryWrapper.eq("data_flag", Integer.valueOf(0))).and(wrapper -> (QueryWrapper)((QueryWrapper)((QueryWrapper)wrapper.eq("creator", "1")).or()).eq("1", "1"));
    List<SetDeviceDeployment> setDeviceDeployments = this.setDeviceDeploymentMapper.selectList((Wrapper)setDeviceDeploymentQueryWrapper);
    Map<String, SetDeviceDeployment> deviceMap = (Map<String, SetDeviceDeployment>)setDeviceDeployments.stream().collect(Collectors.toMap(SetDeviceDeployment::getDeviceIp, Function.identity(), (key1, key2) -> key2));
    List<Student> allStudent = this.serviceUtils.getAllStudent();
    Map<String, Student> studentMap = (Map<String, Student>)allStudent.stream().collect(Collectors.toMap(Student::getStudentId, Function.identity(), (key1, key2) -> key2));
    for (int i = 0; i < everyDay.size(); i++) {
      LinkedList<SourceUserTrail> sourceList = Lists.newLinkedList();
      LinkedList<String> errorRecordList = Lists.newLinkedList();
      Date date = everyDay.get(i);
      try {
        String yyyyMMdd = DateUtil.format(date, "yyyyMMdd");
        String pathDetail = path + File.separator + yyyyMMdd;
        List<File> allFile = getAllFile(new File(pathDetail));
        for (int j = 0; j < allFile.size(); j++) {
          File file = allFile.get(j);
          try {
            String picName = file.getName();
            String actionPic = "/img/" + yyyyMMdd + "/" + picName;
            Timestamp fileCreateTime = getFileCreateTime(file);
            if (!picName.endsWith("[unknown].jpg")) {
              picName = picName.replace("[", "");
              List<String> picNameList = Arrays.asList(picName.split("]"));
              String deviceIp = picNameList.get(0);
              String collectTime = picNameList.get(1);
              String userId = picNameList.get(2);
              if (!studentMap.containsKey(userId)) {
                errorRecordList.add(file.getName());
              } else {
                SetDeviceDeployment setDeviceDeployment = deviceMap.get(deviceIp);
                if (setDeviceDeployment != null) {
                  String areaId = setDeviceDeployment.getAreaId();
                  Integer floor = Integer.valueOf(setDeviceDeployment.getDeviceFloorId());
                  String deviceId = setDeviceDeployment.getDeviceId();
                  SourceUserTrail sourceUserTrail = new SourceUserTrail();
                  sourceUserTrail.setUserid(userId);
                  sourceUserTrail.setAreaid(areaId);
                  sourceUserTrail.setDeviceid(deviceId);
                  sourceUserTrail.setLevel(floor);
                  sourceUserTrail.setCreateTime(fileCreateTime);
                  sourceUserTrail.setCollecttime(fileCreateTime);
                  sourceUserTrail.setActionPic(actionPic);
                  sourceUserTrail.setSysid("861").setUsertype(Integer.valueOf(2)).setActivetype(Integer.valueOf(1)).setDataflag(Integer.valueOf(0));
                  sourceList.add(sourceUserTrail);
                } 
              } 
            } 
          } catch (Exception e) {
            errorRecordList.add(file.getName());
            logger.error("【recoverData】-->{}文件异常-->{}", file.getName(), e.getMessage());
          } 
        } 
      } catch (Exception e) {
        logger.error("【recoverData】-->{}异常-->{}", date, e.getMessage());
      } 
      logger.info("【recoverData】-->{}的记录数为{}", date, Integer.valueOf(sourceList.size()));
      logger.error("【recoverData】-->错误记录数为{}，记录详情为{}", Integer.valueOf(errorRecordList.size()), errorRecordList);
      if (CollectionUtils.isNotEmpty(sourceList)) {
        List<SourceUserTrail> tempList = Lists.newArrayList();
        for (SourceUserTrail sourceUserTrail : sourceList) {
          if (tempList.size() < 999) {
            tempList.add(sourceUserTrail);
            continue;
          } 
          tempList.add(sourceUserTrail);
          this.sourceUserTrailMapper.insertBatch(sourceList);
          tempList.clear();
        } 
        if (tempList.size() > 0) {
          this.sourceUserTrailMapper.insertBatch(sourceList);
          tempList.clear();
        } 
      } 
    } 
  }
  
  public Timestamp getFileCreateTime(File file) throws IOException {
    Path path = Paths.get(file.getAbsolutePath(), new String[0]);
    BasicFileAttributes attrs = Files.readAttributes(path, BasicFileAttributes.class, new java.nio.file.LinkOption[0]);
    FileTime fileTime = attrs.creationTime();
    long millis = fileTime.toMillis();
    SimpleDateFormat dateFormat = new SimpleDateFormat("YYYY-MM-dd HH:mm:ss");
    Timestamp date = new Timestamp(millis);
    return date;
  }
  
  public void updateAlarmInfor(String studentAlarmId, String remark) throws Exception {
    StuAbnormalActionAlarm stuAbnormalActionAlarm = this.stuAbnormalActionAlarmMapper.selectStuAbnormalActionAlarmById(studentAlarmId);
    if (stuAbnormalActionAlarm != null) {
      Integer alarmTypeId = stuAbnormalActionAlarm.getAlarmTypeId();
      String studentId = stuAbnormalActionAlarm.getStudentId();
      Timestamp alarmTime = stuAbnormalActionAlarm.getAlarmTime();
      boolean sameDay = DateUtil.isSameDay(new Date(), alarmTime);
      if (ActionTypeEnum.CODE7.code.equals(alarmTypeId)) {
        if (StringUtils.isNotBlank(remark)) {
          String reasonType = remark.split(":")[0];
          Integer alarmState = null;
          if (AbnormalStateEnum.CODE2.code.equals(stuAbnormalActionAlarm.getAlarmState()) && AskforleaveTypeEnum.CODE1.msg.equals(reasonType))
            alarmState = AbnormalStateEnum.CODE3.code; 
          int result = this.stuAbnormalActionAlarmMapper.updateRemark(studentAlarmId, remark, alarmState);
          if (sameDay && result > 0 && StringUtils.isNotBlank(studentId) && AbnormalStateEnum.CODE2.code
            .equals(stuAbnormalActionAlarm.getAlarmState()) && AskforleaveTypeEnum.CODE1.msg
            .equals(reasonType))
            updateUserSchoolState(studentId); 
        } 
      } else {
        throw new BaseException(ResultStatus.CODE_500.code, "非未到校异常，暂不支持编辑！");
      } 
    } else {
      throw new BaseException(ResultStatus.CODE_502.code, ResultStatus.CODE_502.msg);
    } 
  }
  
  public List<AbnormalStatisticVO> abnormalStatistic(String startTime, String endTime, String schoolId) {
    List<AbnormalStatisticVO> result = Lists.newArrayList();
    List<Integer> alarmTypeIdList = Lists.newArrayList();
    alarmTypeIdList.add(ActionTypeEnum.CODE3.code);
    alarmTypeIdList.add(ActionTypeEnum.CODE4.code);
    alarmTypeIdList.add(ActionTypeEnum.CODE5.code);
    alarmTypeIdList.add(ActionTypeEnum.CODE11.code);
    List<String> schoolIDList = this.dbUtils.getAllSchoolIDList();
    if (CollectionUtils.isEmpty(schoolIDList)) {
      logger.info("【abnormalStatistic】-->schoolID列表为空，{}", schoolIDList);
      return result;
    } 
    if (StrUtil.isNotBlank(schoolId)) {
      schoolIDList.clear();
      schoolIDList.add(schoolId);
    } 
    for (int i = 0; i < schoolIDList.size(); i++) {
      String currentSchoolID = schoolIDList.get(i);
      SchoolIDRequestContext.remove();
      SchoolIDRequestContext.setSchoolIDLocal(currentSchoolID);
      List<AbnormalStatisticVO> abnormalStatisticVOS = Lists.newArrayList();
      SetTermInfo setTermInfo = this.setTermInfoMapper.lastTerm();
      if (ObjectUtils.isEmpty(setTermInfo) || ObjectUtils.isEmpty(setTermInfo.getBegindate()) || ObjectUtils.isEmpty(setTermInfo.getEnddate())) {
        logger.error("【abnormalStatistic】-->schoolID为{}的学期日期有问题；{}", currentSchoolID, setTermInfo);
      } else {
        DateTime dateTime1 = DateUtil.parseDate(DateUtil.format(setTermInfo.getBegindate(), "yyyy-MM-dd"));
        DateTime dateTime2 = DateUtil.parseDate(DateUtil.format(new Date(), "yyyy-MM-dd"));
        if (StrUtil.isNotBlank(startTime))
          dateTime1 = DateUtil.parseDate(startTime); 
        if (StrUtil.isNotBlank(endTime))
          dateTime2 = DateUtil.parseDate(endTime); 
        if (dateTime1.compareTo((Date)dateTime2) > 0) {
          logger.error("【abnormalStatistic】-->schoolID为{}的查询日期有问题；{}--{}", new Object[] { currentSchoolID, dateTime1, dateTime2 });
        } else {
          List<AbnormalStatisticDTO> abnormalStatisticDTOS = this.stuAbnormalActionAlarmMapper.selectAbnormalStatisticList((Date)dateTime1, (Date)dateTime2, alarmTypeIdList);
          Map<Date, List<AbnormalStatisticDTO>> abnormalStatisticDTOSMap = (Map<Date, List<AbnormalStatisticDTO>>)abnormalStatisticDTOS.stream().collect(Collectors.groupingBy(AbnormalStatisticDTO::getRecordTime));
          if (abnormalStatisticDTOSMap != null) {
            abnormalStatisticDTOSMap.forEach((key, valList) -> {
                  AbnormalStatisticVO abnormalStatisticVO = new AbnormalStatisticVO();
                  int tViolateCount = valList.stream().mapToInt(AbnormalStatisticDTO::getTViolateCount).sum();
                  AbnormalStatisticDTO abnormalStatisticDTO = valList.stream().filter(()).findAny().orElse(null);
                  abnormalStatisticVO.setSchoolId(currentSchoolID);
                  abnormalStatisticVO.setRecordTime(DateUtil.format(key, "yyyy-MM-dd"));
                  abnormalStatisticVO.setTViolateCount(Integer.valueOf(tViolateCount));
                  abnormalStatisticVO.setTClimbCount(Integer.valueOf(ObjectUtils.isEmpty(abnormalStatisticDTO) ? 0 : abnormalStatisticDTO.getTViolateCount().intValue()));
                  abnormalStatisticVO.setTFightCount(Integer.valueOf(0));
                  abnormalStatisticVOS.add(abnormalStatisticVO);
                });
            String todayStr = DateUtil.format(new Date(), "yyyy-MM-dd");
            AbnormalStatisticVO abnormalStatisticVO = abnormalStatisticVOS.stream().filter(record -> todayStr.equals(record.getRecordTime())).findAny().orElse(null);
            if (ObjectUtils.isNotEmpty(abnormalStatisticVO)) {
              abnormalStatisticVO.setTViolateCount(null);
              abnormalStatisticVO.setTClimbCount(null);
              abnormalStatisticVO.setTFightCount(null);
            } else if (DateUtil.isSameDay((Date)dateTime2, new Date())) {
              AbnormalStatisticVO trailRecord = new AbnormalStatisticVO(currentSchoolID, todayStr, null, null, null, null, null, null);
              abnormalStatisticVOS.add(trailRecord);
            } 
            result.addAll(abnormalStatisticVOS);
          } 
        } 
      } 
    } 
    SchoolIDRequestContext.remove();
    return result;
  }
  
  public List<AbnormalNumOfAreaStatisticVO> countAbnormalNumByAreaId(Integer userType, String userId, String startTime, String endTime, String campusId) {
    List<AbnormalNumOfAreaStatisticVO> result = Lists.newArrayList();
    Timestamp startTime1 = Timestamp.valueOf(startTime);
    Timestamp endTime1 = Timestamp.valueOf(endTime);
    List<ThirdAreaDto> allBuildingByCampusId = this.serviceUtils.getAllBuildingByCampusId(campusId);
    if (allBuildingByCampusId.size() == 1 && ((ThirdAreaDto)allBuildingByCampusId.get(0)).getBuildingId().intValue() == -1)
      return result; 
    List<String> buildingIds = (List<String>)allBuildingByCampusId.stream().map(obj -> {
          s = new String();
          return obj.getBuildingId() + "";
        }).collect(Collectors.toList());
    Map<String, String> areaIdAndAreaNameMap = (Map<String, String>)allBuildingByCampusId.stream().collect(Collectors.toMap(e -> e.getBuildingId() + "", e -> (e.getBuildingName() == null) ? "" : e.getBuildingName(), (key1, key2) -> key2));
    logger.info("【countAbnormalNumByAreaId】-->buildingIds-->{}", buildingIds);
    List<AbnormalNumOfAreaStatisticVO> alarmsCount = Lists.newArrayList();
    try {
      alarmsCount = this.stuAbnormalActionAlarmMapper.selectAbnormalNumByAreaId(userId, userType, startTime1, endTime1, buildingIds);
      if (CollectionUtils.isNotEmpty(alarmsCount)) {
        alarmsCount.stream().forEach(obj -> {
              String alarmAreaId = obj.getAlarmAreaId();
              if (StringUtils.isNotBlank(alarmAreaId)) {
                String areaName = (String)areaIdAndAreaNameMap.get(alarmAreaId);
                obj.setAlarmAreaName(areaName);
              } 
            });
        return alarmsCount;
      } 
    } catch (Exception e) {
      logger.error("【countAbnormalNumByAreaId】报错：", e);
    } 
    return result;
  }
  
  public List<File> getAllFile(File dirFile) {
    if (Objects.isNull(dirFile) || !dirFile.exists() || dirFile.isFile())
      return null; 
    File[] childrenFiles = dirFile.listFiles();
    if (Objects.isNull(childrenFiles) || childrenFiles.length == 0)
      return null; 
    List<File> files = new ArrayList<>();
    for (File childFile : childrenFiles) {
      if (childFile.isFile())
        files.add(childFile); 
    } 
    return files;
  }
  
  public String getPercentByNum(Integer targetNum, Integer abnormalSum) {
    if (ObjectUtils.isNotEmpty(targetNum)) {
      BigDecimal beforeDeal = (new BigDecimal((targetNum.intValue() / abnormalSum.intValue()))).setScale(4, 4);
      BigDecimal rateStr = beforeDeal.multiply(new BigDecimal(100)).setScale(2, 1);
      return rateStr.toString() + "%";
    } 
    return "0.00%";
  }
  
  public void updateAbnormalStatus(String alarmId, String teacherId) throws Exception {
    StuAbnormalActionAlarm stuAbnormalActionAlarm = this.stuAbnormalActionAlarmMapper.selectStuAbnormalActionAlarmById(alarmId);
    logger.info("【updateAbnormalStatus】-->stuAbnormalActionAlarm-->{}", stuAbnormalActionAlarm);
    if (stuAbnormalActionAlarm != null) {
      Integer alarmState = stuAbnormalActionAlarm.getAlarmState();
      String studentId = stuAbnormalActionAlarm.getStudentId();
      Timestamp alarmTime = stuAbnormalActionAlarm.getAlarmTime();
      boolean sameDay = DateUtil.isSameDay(new Date(), alarmTime);
      Integer state = AbnormalStateEnum.CODE1.code;
      if (AbnormalStateEnum.CODE2.code.equals(alarmState)) {
        state = AbnormalStateEnum.CODE3.code;
        if (StringUtils.isNotBlank(studentId))
          if (sameDay) {
            updateUserSchoolState(studentId);
          } else {
            Set<String> userIdSet = new HashSet<>();
            userIdSet.add(studentId);
            LocalDate localDate = alarmTime.toInstant().atZone(ZoneId.systemDefault()).toLocalDate();
            this.stuAbnormalActionAlarmMapper.updateStatusOfActionType7(userIdSet, localDate, ActionTypeEnum.CODE7.code, AbnormalStateEnum.CODE3.code, AskforleaveTypeEnum.CODE1.msg + ":");
          }  
      } 
      stuAbnormalActionAlarm.setLastEditTime(new Timestamp((new Date()).getTime()));
      Integer result = Integer.valueOf(this.stuAbnormalActionAlarmMapper.updateAbnormalStatus(alarmId, teacherId, state));
      logger.info("【updateAbnormalStatus】-->result-->{}", result);
      if (result.equals(Integer.valueOf(0)))
        throw new BaseException(ResultStatus.CODE_500.code, "更新失败"); 
    } else {
      throw new BaseException(ResultStatus.CODE_502.code, ResultStatus.CODE_502.msg);
    } 
  }
  
  public void updateUserSchoolState(String studentId) throws Exception {
    CountUserSchool stateByUserId = this.serviceUtils.getStateByUserId(studentId);
    if (ObjectUtils.isNotEmpty(stateByUserId) && StudentSchoolStateEnum.CODE1.code.equals(stateByUserId.getStatus())) {
      StateDTO stateDTO = new StateDTO(DateUtil.format(new Date(), "yyyy-MM-dd HH:mm:ss"), null, StudentSchoolStateEnum.CODE2.code);
      HashMap<String, StateDTO> stringStateDTOHashMap = new HashMap<>();
      stringStateDTOHashMap.put(studentId, stateDTO);
      this.countUserSchoolService.pushState(stringStateDTOHashMap);
    } 
  }
  
  public void pushAbnormalToWeCharUpgrade(List<StuAbnormalActionAlarm> abnormalList) {
    if (ListUtils.isEmpty(abnormalList))
      return; 
    List<MsgInfoSettingVO> setList = null;
    try {
      setList = this.setInfoSettingService.getList();
    } catch (Exception e) {
      logger.error("【pushAbnormalToWeCharUpgrade】-->获取列表失败：", e);
    } 
    if (ListUtils.isEmpty(setList))
      return; 
    SchoolInfor schoolInfor = this.serviceUtils.getSchoolInfor();
    if (schoolInfor == null)
      return; 
    List<MsgInfoSettingVO> finalSetList = setList;
    for (int i = 0; i < abnormalList.size(); i++) {
      StuAbnormalActionAlarm abnormal = abnormalList.get(i);
      Optional<MsgInfoSettingVO> first = finalSetList.stream().filter(f -> (abnormal.getAlarmTypeId() + "").equals(f.getAlarmTypeId())).findFirst();
      if (first.isPresent()) {
        String infoTypes = ((MsgInfoSettingVO)first.get()).getInfoTypes();
        if (!StringUtils.isEmpty(infoTypes) && infoTypes.contains("2")) {
          String usersId = ((MsgInfoSettingVO)first.get()).getUsersId();
          if (!StringUtils.isEmpty(usersId)) {
            String[] split = usersId.split(",");
            if (split != null)
              for (String s : split) {
                WeCharPushVO weCharPushVO = new WeCharPushVO();
                weCharPushVO.setSchoolID(schoolInfor.getSchoolId());
                weCharPushVO.setSchoolName(schoolInfor.getSchoolName());
                weCharPushVO.setUserID(s);
                weCharPushVO.setNotifyUserName("校园活动轨迹系统");
                weCharPushVO.setNotifyTime(new Timestamp(System.currentTimeMillis()));
                weCharPushVO.setContent(abnormal.getAlarmDescription());
                try {
                  this.thirdService.pushMsgToWeCharApp(weCharPushVO);
                  logger.info("异常轨迹推送到消息中心系统成功");
                } catch (Exception e) {
                  logger.error("异常轨迹推送到消息中心系统失败");
                  logger.error(e.getStackTrace().toString());
                } 
              }  
          } 
        } 
      } 
    } 
  }
  
  public void pushDangerRegionToWeChar(StuAbnormalActionAlarm abnormalInfor, SetUserImportant userImportant) {
    SchoolInfor schoolInfor = this.serviceUtils.getSchoolInfor();
    if (schoolInfor == null)
      return; 
    Set<String> notifyUserIdSet = new HashSet<>();
    List<SetInfoSetting> setInfoSettings = this.setInfoSettingMapper.selectListByNull();
    if (userImportant != null) {
      String guardiansId = userImportant.getGuardiansId();
      if (StrUtil.isNotBlank(guardiansId)) {
        Set<String> collect = (Set<String>)Arrays.<String>stream(guardiansId.split(",")).filter(u -> StrUtil.isNotBlank(u)).collect(Collectors.toSet());
        if (CollectionUtils.isNotEmpty(collect))
          notifyUserIdSet.addAll(collect); 
      } 
    } 
    if (CollectionUtils.isNotEmpty(setInfoSettings)) {
      SetInfoSetting setInfoSettingByAlarmType = setInfoSettings.stream().filter(setInfoSetting -> setInfoSetting.getAlarmTypeId().equals(abnormalInfor.getAlarmTypeId() + "")).findAny().orElse(null);
      if (setInfoSettingByAlarmType != null) {
        String infoTypes = setInfoSettingByAlarmType.getInfoTypes();
        if (StrUtil.isNotBlank(infoTypes) && infoTypes.contains("2")) {
          String usersId = setInfoSettingByAlarmType.getUsersId();
          if (StrUtil.isNotBlank(usersId)) {
            Set<String> collect = (Set<String>)Arrays.<String>stream(usersId.split(",")).filter(u -> StrUtil.isNotBlank(u)).collect(Collectors.toSet());
            if (CollectionUtils.isNotEmpty(collect))
              notifyUserIdSet.addAll(collect); 
          } 
        } 
      } 
    } 
    String description = abnormalInfor.getAlarmDescription().substring(19 + "".length());
    notifyUserIdSet.stream().forEach(userId -> {
          WeCharPushVO weCharPushVO = new WeCharPushVO();
          weCharPushVO.setSchoolID(schoolInfor.getSchoolId());
          weCharPushVO.setSchoolName(schoolInfor.getSchoolName());
          weCharPushVO.setUserID(userId);
          weCharPushVO.setNotifyUserName("校园活动轨迹系统");
          weCharPushVO.setNotifyTime(new Timestamp(System.currentTimeMillis()));
          weCharPushVO.setContent(description);
          try {
            this.thirdService.pushMsgToWeCharApp(weCharPushVO);
            logger.info("异常轨迹推送到监护人微信成功");
          } catch (Exception e) {
            logger.error("异常轨迹推送到监护人微信失败");
            logger.error(e.getStackTrace().toString());
          } 
        });
  }
  
  public static ConcurrentLinkedQueue<StuAbnormalActionAlarmQueue> actionAlarms = new ConcurrentLinkedQueue<>();
  
  public StuAbnormalActionAlarm checkAbnormal(ActionDataVO actionData, WebUserInfo userInfor, WebDeviceEntity deviceInfor, SourceUserTrail sourceUserTrail, boolean rightSource) {
    String schoolID = SchoolIDRequestContext.getSchoolIDLocal();
    String calculateAddress = ObjFillUtils.getCalculateAddress();
    boolean isImportantStu = false, isInDangerRegionAgain = false;
    SetUserImportant setUserImportant = this.setUserImportantMapper.selectByUSerId(actionData.getUserId());
    if (setUserImportant != null)
      isImportantStu = true; 
    String actionTime = actionData.getActionTime().replaceAll("[^0-9]", "");
    StuAbnormalActionAlarm stuAbnormalActionAlarm = new StuAbnormalActionAlarm();
    stuAbnormalActionAlarm.setStudentId(userInfor.getUserId());
    stuAbnormalActionAlarm.setStudentName(userInfor.getUserName());
    stuAbnormalActionAlarm.setStudentPic(userInfor.getPhotoPic());
    stuAbnormalActionAlarm.setClassId(userInfor.getClassId());
    stuAbnormalActionAlarm.setClassName(userInfor.getClassName());
    stuAbnormalActionAlarm.setGradeId(userInfor.getGradeId());
    stuAbnormalActionAlarm.setAlarmAreaId(deviceInfor.getAreaId());
    stuAbnormalActionAlarm.setAlarmAreaName(deviceInfor.getAreaName());
    stuAbnormalActionAlarm.setAlarmState(Integer.valueOf(0));
    stuAbnormalActionAlarm.setAlarmDeviceId(deviceInfor.getThirdDeviceId());
    stuAbnormalActionAlarm.setAlarmTime(Timestamp.valueOf(actionData.getActionTime()));
    stuAbnormalActionAlarm.setCreateTime(new Timestamp((new Date()).getTime()));
    stuAbnormalActionAlarm.setCreator("");
    if (actionData.getActionType().intValue() != 1 && actionData.getActionType().intValue() != 2 && actionData.getActionType().intValue() != 11) {
      boolean isRLock = false, isInsert = true;
      stuAbnormalActionAlarm.setAlarmTypeId(actionData.getActionType());
      stuAbnormalActionAlarm.setAlarmTypeName(ActionTypeEnum.getNameByKey(actionData.getActionType()));
      if (actionData.getActionType().intValue() == 3) {
        stuAbnormalActionAlarm.setAlarmSubject("疑似攀墙");
        stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getAreaName() + "检测到攀爬围墙危险异常");
      } else if (actionData.getActionType().intValue() == 4) {
        stuAbnormalActionAlarm.setAlarmSubject("疑似涉水");
        stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getAreaName() + "检测到涉水危险异常");
      } else if (actionData.getActionType().intValue() == 5) {
        stuAbnormalActionAlarm.setAlarmSubject("疑似聚集");
        stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getAreaName() + (StringUtils.isEmpty(deviceInfor.getBuildingFloor()) ? "" : (deviceInfor.getBuildingFloor() + "楼")) + "检测到室内人员聚集异常");
      } else {
        if (actionData.getActionType().intValue() == 20) {
          stuAbnormalActionAlarm.setAlarmSubject("进入危险区域");
          stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getAreaName() + (StringUtils.isEmpty(deviceInfor.getBuildingFloor()) ? " " : (deviceInfor.getBuildingFloor() + "楼")) + "抓拍到" + stuAbnormalActionAlarm.getStudentName() + "多次进入危险区域(" + deviceInfor.getDeviceName() + ")");
          RLock lock = this.redisson.getLock("track:ALLITERATIVE");
          try {
            if (lock.tryLock(5L, TimeUnit.SECONDS) || lock.tryLock()) {
              logger.info("开始时间：{}", DateUtil.format(new Date(), "yyyy-MM-dd HH:mm:ss SSS"));
              isRLock = true;
              List<Timestamp> timeAndCountFromRedis = this.objectMapper.<List<Timestamp>>convertValue(this.redisUtil.hget("track:noDelete:dangerRegion:student", stuAbnormalActionAlarm.getStudentId()), (TypeReference<List<Timestamp>>)new Object(this));
              if (CollectionUtils.isNotEmpty(timeAndCountFromRedis)) {
                Timestamp alarmTime = timeAndCountFromRedis.get(0);
                Timestamp newTime = stuAbnormalActionAlarm.getAlarmTime();
                if (checkDangerRegion(alarmTime, newTime).booleanValue()) {
                  timeAndCountFromRedis.add(newTime);
                  int dangerTimes = timeAndCountFromRedis.size();
                  if (Constans.DANGER_TIMES_MAX.equals(Integer.valueOf(dangerTimes))) {
                    isInDangerRegionAgain = true;
                    List<SourceUserTrail> sourceUserTrailList = this.sourceUserTrailMapper.selectByUserIdAndTime(sourceUserTrail.getUserid(), timeAndCountFromRedis);
                    if (CollectionUtils.isNotEmpty(sourceUserTrailList)) {
                      StringBuilder sb = new StringBuilder();
                      String date = new String();
                      for (int i = 0; i < sourceUserTrailList.size(); i++) {
                        SourceUserTrail record = sourceUserTrailList.get(i);
                        date = DateUtil.format(record.getCollecttime(), "yyyyMMdd");
                        sb.append(date).append("_").append(record.getId());
                        if (i != sourceUserTrailList.size() - 1)
                          sb.append(","); 
                      } 
                      stuAbnormalActionAlarm.setAlarmRelatePic(sb.toString());
                    } 
                    this.redisUtil.hdel("track:noDelete:dangerRegion:student", new Object[] { sourceUserTrail.getUserid() });
                  } else {
                    this.redisUtil.hset("track:noDelete:dangerRegion:student", sourceUserTrail.getUserid(), timeAndCountFromRedis);
                    isInsert = false;
                  } 
                } else {
                  removeUnqualifiedTime(timeAndCountFromRedis, newTime);
                  timeAndCountFromRedis.add(newTime);
                  this.redisUtil.hset("track:noDelete:dangerRegion:student", sourceUserTrail.getUserid(), timeAndCountFromRedis);
                  isInsert = false;
                } 
              } else {
                List<Timestamp> alarmTimeList = new ArrayList<>();
                alarmTimeList.add(stuAbnormalActionAlarm.getAlarmTime());
                this.redisUtil.hset("track:noDelete:dangerRegion:student", sourceUserTrail.getUserid(), alarmTimeList);
                isInsert = false;
              } 
              while (true) {
                StuAbnormalActionAlarmQueue alarm = actionAlarms.poll();
                if (alarm != null) {
                  dangerAbnormalDeal(alarm);
                  continue;
                } 
                break;
              } 
            } else {
              logger.info("未获取到锁，将数据保存在队列中");
              StuAbnormalActionAlarmQueue stuAbnormalActionAlarmQueue = new StuAbnormalActionAlarmQueue();
              BeanUtils.copyProperties(stuAbnormalActionAlarm, stuAbnormalActionAlarmQueue);
              stuAbnormalActionAlarmQueue.setSchoolID(schoolID);
              actionAlarms.offer(stuAbnormalActionAlarmQueue);
              isInsert = false;
            } 
          } catch (InterruptedException e) {
            logger.error("线程中断异常,信息:{}", e.toString());
          } finally {
            logger.info("结束时间：{}", DateUtil.format(new Date(), "yyyy-MM-dd HH:mm:ss SSS"));
            if (isRLock)
              lock.unlock(); 
          } 
          String str = this.thirdService.syncAbnormalPicUri(calculateAddress, actionData.getActionPic(), actionData.getActionMov(), actionData.getSysId(), userInfor.getUserId(), actionTime, null);
          if (str != null && !Objects.equals("track_calculate", str)) {
            String[] url = str.split(",");
            if (!Objects.equals("null", url[0]))
              sourceUserTrail.setActionPic(url[0]); 
            if (!Objects.equals("null", url[1])) {
              sourceUserTrail.setActionMov(url[1]);
            } else if (Objects.equals("null", url[0])) {
              logger.error("其他系统推送照片资源{}同步失败", actionData.getActionPic());
            } else if (Objects.equals("null", url[1])) {
              logger.error("其他系统推送视频资源{}同步失败", actionData.getActionMov());
            } 
            this.sourceUserTrailMapper.updateIdTrail(sourceUserTrail);
          } else if (Objects.equals("track_calculate", str)) {
            logger.info("学生" + ((actionData.getActionType().intValue() == 3) ? "疑似攀爬围墙危险" : ((actionData.getActionType().intValue() == 4) ? "疑似学生涉水危险" : "人员聚集危险")) + "异常图片从计算端同步到本地:" + actionData
                .getActionPic());
            sourceUserTrail.setActionPic(actionData.getActionPic());
            this.sourceUserTrailMapper.updateIdTrail(sourceUserTrail);
            SetDeviceDeployment setDeviceDeployment = this.setDeviceDeploymentMapper.selectByIdAndActionType(actionData.getDeviceId(), actionData.getActionType());
            SetNvrHost setNvrHost = (SetNvrHost)this.setNvrHostMapper.selectOne((Wrapper)((QueryWrapper)(new QueryWrapper()).eq("host_ip", setDeviceDeployment.getRecordServerIp())).and(wrapper -> (QueryWrapper)((QueryWrapper)((QueryWrapper)wrapper.eq("creator", "1")).or()).eq("1", "1")));
            this.resourceDownloadUtils.downloadVideoByImportantStuTask(setDeviceDeployment, setNvrHost, Timestamp.valueOf(actionData.getActionTime()), sourceUserTrail.getId());
          } else {
            logger.error("通过第三方调用计算端接口获取信息失败");
          } 
          if (isInsert) {
            this.stuAbnormalActionAlarmMapper.insert(stuAbnormalActionAlarm);
            if (isInDangerRegionAgain) {
              this.pushDataService.pushDangerRegionToMsgCenter(stuAbnormalActionAlarm);
              pushDangerRegionToWeChar(stuAbnormalActionAlarm, setUserImportant);
            } 
          } 
          return null;
        } 
        logger.info("过滤掉未知类型异常数据");
        return null;
      } 
      this.stuAbnormalActionAlarmMapper.insert(stuAbnormalActionAlarm);
      List<StuAbnormalActionAlarm> pushData = new ArrayList();
      pushData.add(stuAbnormalActionAlarm);
      if (!stuAbnormalActionAlarm.getAlarmTypeId().equals(Integer.valueOf(20))) {
        this.pushDataService.pushAbnormalToMsgCenter(pushData);
        this.abnormalManageService.pushAbnormalToWeCharUpgrade(pushData);
      } 
      String isSuccess = this.thirdService.syncAbnormalPicUri(calculateAddress, actionData.getActionPic(), actionData.getActionMov(), actionData.getSysId(), userInfor.getUserId(), actionTime, null);
      if (isSuccess != null && !Objects.equals("track_calculate", isSuccess)) {
        String[] url = isSuccess.split(",");
        if (!Objects.equals("null", url[0])) {
          if ((isImportantStu || SystemParam.ImgStatus.intValue() == 1) && rightSource)
            sourceUserTrail.setActionPic(url[0]); 
          stuAbnormalActionAlarm.setAlarmRelatePic(url[0]);
        } 
        if (!Objects.equals("null", url[1])) {
          if ((isImportantStu || SystemParam.ImgStatus.intValue() == 1) && rightSource)
            sourceUserTrail.setActionMov(url[1]); 
          stuAbnormalActionAlarm.setAlarmRelateMov(url[1]);
        } else if (Objects.equals("null", url[0])) {
          logger.error("其他系统推送照片资源{}同步失败", actionData.getActionPic());
        } else if (Objects.equals("null", url[1])) {
          logger.error("其他系统推送视频资源{}同步失败", actionData.getActionMov());
        } 
        if ((isImportantStu || SystemParam.ImgStatus.intValue() == 1) && rightSource)
          this.sourceUserTrailMapper.updateIdTrail(sourceUserTrail); 
        this.stuAbnormalActionAlarmMapper.updateAlarmRelatePicAndAlarmRelateMov(stuAbnormalActionAlarm);
      } else if (Objects.equals("track_calculate", isSuccess)) {
        logger.info("学生" + ((actionData.getActionType().intValue() == 3) ? "疑似攀爬围墙危险" : ((actionData.getActionType().intValue() == 4) ? "疑似学生涉水危险" : "人员聚集危险")) + "异常图片从计算端同步到本地:" + actionData
            .getActionPic());
        stuAbnormalActionAlarm.setAlarmRelatePic(actionData.getActionPic());
        this.stuAbnormalActionAlarmMapper.updateAlarmRelatePicAndAlarmRelateMov(stuAbnormalActionAlarm);
        if ((isImportantStu || SystemParam.ImgStatus.intValue() == 1) && rightSource) {
          sourceUserTrail.setActionPic(actionData.getActionPic());
          this.sourceUserTrailMapper.updateIdTrail(sourceUserTrail);
        } 
        if (isImportantStu) {
          SetDeviceDeployment setDeviceDeployment = this.setDeviceDeploymentMapper.selectByIdAndActionType(actionData.getDeviceId(), actionData.getActionType());
          SetNvrHost setNvrHost = (SetNvrHost)this.setNvrHostMapper.selectOne((Wrapper)((QueryWrapper)(new QueryWrapper()).eq("host_ip", setDeviceDeployment.getRecordServerIp())).and(wrapper -> (QueryWrapper)((QueryWrapper)((QueryWrapper)wrapper.eq("creator", "1")).or()).eq("1", "1")));
          this.resourceDownloadUtils.downloadVideoByImportantStuTask(setDeviceDeployment, setNvrHost, Timestamp.valueOf(actionData.getActionTime()), sourceUserTrail.getId());
        } 
      } else {
        logger.error("通过第三方调用计算端接口获取信息失败");
      } 
      SetDeviceDeployment schoolDeviceDeployment = this.setDeviceDeploymentMapper.selectByIdAndActionType(actionData.getDeviceId(), actionData.getActionType());
      SetNvrHost recordHost = (SetNvrHost)this.setNvrHostMapper.selectOne((Wrapper)((QueryWrapper)(new QueryWrapper()).eq("host_ip", schoolDeviceDeployment.getRecordServerIp())).and(wrapper -> (QueryWrapper)((QueryWrapper)((QueryWrapper)wrapper.eq("creator", "1")).or()).eq("1", "1")));
      this.resourceDownloadUtils.downloadVideoByActionTask(schoolDeviceDeployment, recordHost, Timestamp.valueOf(actionData.getActionTime()), stuAbnormalActionAlarm.getStudentAlarmId());
      return stuAbnormalActionAlarm;
    } 
    if ((isImportantStu || SystemParam.ImgStatus.intValue() == 1) && rightSource) {
      String isSuccess = this.thirdService.syncAbnormalPicUri(calculateAddress, actionData.getActionPic(), actionData.getActionMov(), actionData.getSysId(), userInfor.getUserId(), actionTime, null);
      if (isSuccess != null && !Objects.equals("track_calculate", isSuccess)) {
        String[] url = isSuccess.split(",");
        if (!Objects.equals("null", url[0]))
          sourceUserTrail.setActionPic(url[0]); 
        if (!Objects.equals("null", url[1])) {
          sourceUserTrail.setActionMov(url[1]);
        } else if (Objects.equals("null", url[0])) {
          logger.error("其他系统推送照片资源{}同步失败", actionData.getActionPic());
        } else if (Objects.equals("null", url[1])) {
          logger.error("其他系统推送视频资源{}同步失败", actionData.getActionMov());
        } 
        this.sourceUserTrailMapper.updateIdTrail(sourceUserTrail);
      } else if (Objects.equals("track_calculate", isSuccess)) {
        sourceUserTrail.setActionPic(actionData.getActionPic());
        this.sourceUserTrailMapper.updateIdTrail(sourceUserTrail);
        logger.info("学生轨迹点照片{}从计算端同步到本地失败或者已同步，轨迹类型：{}", actionData.getActionPic(), SystemParam.ImgStatus);
      } else {
        logger.error("通过第三方调用计算端接口获取信息失败");
      } 
      if (isImportantStu) {
        SetDeviceDeployment schoolDeviceDeployment = this.setDeviceDeploymentMapper.selectByIdAndActionType(actionData.getDeviceId(), actionData.getActionType());
        SetNvrHost recordHost = (SetNvrHost)this.setNvrHostMapper.selectOne((Wrapper)((QueryWrapper)(new QueryWrapper()).eq("host_ip", schoolDeviceDeployment.getRecordServerIp())).and(wrapper -> (QueryWrapper)((QueryWrapper)((QueryWrapper)wrapper.eq("creator", "1")).or()).eq("1", "1")));
        this.resourceDownloadUtils.downloadVideoByImportantStuTask(schoolDeviceDeployment, recordHost, Timestamp.valueOf(actionData.getActionTime()), sourceUserTrail.getId());
      } 
    } 
    if (actionData.getActionType().intValue() != 11 && "861".equals(actionData.getSysId()))
      qiaokeQueue.add(actionData); 
    return null;
  }
  
  private void removeUnqualifiedTime(List<Timestamp> timeAndCount, Timestamp newAlarmTime) {
    if (CollectionUtils.isNotEmpty(timeAndCount) && ObjectUtils.isNotEmpty(newAlarmTime))
      for (int i = 0; i < timeAndCount.size(); i++) {
        Timestamp oldAlarmTime = timeAndCount.get(i);
        if (checkDangerRegion(oldAlarmTime, newAlarmTime).booleanValue())
          break; 
        timeAndCount.remove(i);
      }  
  }
  
  public void dangerAbnormalDeal(StuAbnormalActionAlarmQueue stuAbnormalActionAlarmQueue) {
    String schoolIDLocal = SchoolIDRequestContext.getSchoolIDLocal();
    try {
      SchoolIDRequestContext.setSchoolIDLocal(stuAbnormalActionAlarmQueue.getSchoolID());
      StuAbnormalActionAlarm stuAbnormalActionAlarm = new StuAbnormalActionAlarm();
      BeanUtils.copyProperties(stuAbnormalActionAlarmQueue, stuAbnormalActionAlarm);
      SetUserImportant userImportantFromQueue = this.setUserImportantMapper.selectByUSerId(stuAbnormalActionAlarm.getStudentId());
      List<Timestamp> timeAndCountFromQueue = this.objectMapper.<List<Timestamp>>convertValue(this.redisUtil.hget("track:noDelete:dangerRegion:student", stuAbnormalActionAlarm.getStudentId()), (TypeReference<List<Timestamp>>)new Object(this));
      if (CollectionUtils.isNotEmpty(timeAndCountFromQueue)) {
        logger.info("【dangerAbnormalDeal】-->走了队列处理异常数据");
        Timestamp alarmTime = timeAndCountFromQueue.get(0);
        Timestamp newTime = stuAbnormalActionAlarm.getAlarmTime();
        if (checkDangerRegion(alarmTime, newTime).booleanValue()) {
          timeAndCountFromQueue.add(newTime);
          int dangerTimes = timeAndCountFromQueue.size();
          if (Constans.DANGER_TIMES_MAX.equals(Integer.valueOf(dangerTimes))) {
            List<SourceUserTrail> sourceUserTrailList = this.sourceUserTrailMapper.selectByUserIdAndTime(stuAbnormalActionAlarm.getStudentId(), timeAndCountFromQueue);
            if (CollectionUtils.isNotEmpty(sourceUserTrailList)) {
              StringBuilder sb = new StringBuilder();
              String date = new String();
              for (int i = 0; i < sourceUserTrailList.size(); i++) {
                SourceUserTrail record = sourceUserTrailList.get(i);
                date = DateUtil.format(record.getCollecttime(), "yyyyMMdd");
                sb.append(date).append("_").append(record.getId());
                if (i != sourceUserTrailList.size() - 1)
                  sb.append(","); 
              } 
              stuAbnormalActionAlarm.setAlarmRelatePic(sb.toString());
            } 
            this.stuAbnormalActionAlarmMapper.insert(stuAbnormalActionAlarm);
            this.pushDataService.pushDangerRegionToMsgCenter(stuAbnormalActionAlarm);
            pushDangerRegionToWeChar(stuAbnormalActionAlarm, userImportantFromQueue);
            this.redisUtil.hdel("track:noDelete:dangerRegion:student", new Object[] { stuAbnormalActionAlarm.getStudentId() });
          } else {
            this.redisUtil.hset("track:noDelete:dangerRegion:student", stuAbnormalActionAlarm.getStudentId(), timeAndCountFromQueue);
          } 
        } else {
          removeUnqualifiedTime(timeAndCountFromQueue, newTime);
          timeAndCountFromQueue.add(newTime);
          this.redisUtil.hset("track:noDelete:dangerRegion:student", stuAbnormalActionAlarm.getStudentId(), timeAndCountFromQueue);
        } 
      } else {
        List<Timestamp> alarmTimeList = new ArrayList<>();
        alarmTimeList.add(stuAbnormalActionAlarm.getAlarmTime());
        this.redisUtil.hset("track:noDelete:dangerRegion:student", stuAbnormalActionAlarm.getStudentId(), alarmTimeList);
      } 
    } catch (Exception e) {
      logger.error(e.getMessage());
    } finally {
      SchoolIDRequestContext.setSchoolIDLocal(schoolIDLocal);
    } 
  }
  
  public Boolean checkDangerRegion(Timestamp oldTime, Timestamp newTime) {
    if (oldTime != null && newTime != null) {
      long beginTime = oldTime.getTime();
      long endedTime = newTime.getTime();
      long diff = Math.abs(endedTime - beginTime);
      if (diff >= 0L && diff <= 180000L)
        return Boolean.valueOf(true); 
    } 
    return Boolean.valueOf(false);
  }
  
  public Map<String, Object> getStudentsByAbnormalId(String alarmId, Integer pageNum, Integer pageSize) {
    try {
      String fightTimeRange = this.env.getProperty("track.fightTimeRange");
      int timeRange = StringUtils.isBlank(fightTimeRange) ? 5 : Integer.parseInt(fightTimeRange);
      StuAbnormalActionAlarm stuAbnormalActionAlarm = this.stuAbnormalActionAlarmMapper.selectStuAbnormalActionAlarmById(alarmId);
      String deviceId = stuAbnormalActionAlarm.getAlarmDeviceId();
      logger.info("查找到该欺凌记录的报警盒设备id为：{}", deviceId);
      LocalDateTime alarmTime = stuAbnormalActionAlarm.getAlarmTime().toLocalDateTime();
      SetDeviceDeployment setDeviceDeployment = this.setDeviceDeploymentMapper.selectByDeviceId(deviceId);
      if (Objects.isNull(setDeviceDeployment))
        return PageUtil.startPage(new ArrayList(), pageNum, pageSize); 
      String bindCamIds = setDeviceDeployment.getBindCamIds();
      if (StringUtils.isBlank(bindCamIds))
        return PageUtil.startPage(new ArrayList(), pageNum, pageSize); 
      List<String> camIds = (List<String>)Arrays.<String>stream(bindCamIds.split(",")).collect(Collectors.toList());
      List<SetDeviceDeployment> setDeviceDeployments = this.setDeviceDeploymentMapper.selectByDeviceIds(camIds);
      LocalDateTime now = LocalDateTime.now();
      Date beginDate = Date.from(alarmTime.minusMinutes(timeRange).atZone(ZoneId.systemDefault()).toInstant());
      Duration duration = Duration.between(alarmTime, now);
      List<SourceUserTrail> userTrails = new ArrayList<>();
      for (SetDeviceDeployment deviceDeployment : setDeviceDeployments) {
        if (duration.toMinutes() >= timeRange) {
          logger.info("当前时间大于异常记录时间 + 指定时间范围,开始查找异常记录前后{}分钟内的抓拍记录", Integer.valueOf(timeRange));
          Date date = Date.from(alarmTime.plusMinutes(timeRange).atZone(ZoneId.systemDefault()).toInstant());
          List<SourceUserTrail> list = this.sourceUserTrailMapper.getTrackByCollectTimeAndDeviceId(beginDate, date, deviceDeployment.getDeviceId());
          userTrails.addAll(list);
          continue;
        } 
        logger.info("当前时间小于于异常记录时间 + 指定时间范围,开始查找异常记录前{}分钟到当前时间内的抓拍记录", fightTimeRange);
        Date endDate = Date.from(now.atZone(ZoneId.systemDefault()).toInstant());
        List<SourceUserTrail> sourceUserTrailList = this.sourceUserTrailMapper.getTrackByCollectTimeAndDeviceId(beginDate, endDate, deviceDeployment.getDeviceId());
        userTrails.addAll(sourceUserTrailList);
      } 
      List<BullyingDetailDTO> bullyingDetailList = new ArrayList<>();
      List<BullyingDetailDTO> finalBullyingDetailList = bullyingDetailList;
      Map<String, List<SourceUserTrail>> userTrailMap = (Map<String, List<SourceUserTrail>>)userTrails.stream().filter(sourceUserTrail -> UserType.STUDENT.getCode().equals(sourceUserTrail.getUsertype())).collect(Collectors.groupingBy(SourceUserTrail::getUserid));
      List<Student> students = this.objectMapper.<List<Student>>convertValue(this.redisUtil.get("base:student"), (TypeReference<List<Student>>)new Object(this));
      Map<String, Student> studentMap = (Map<String, Student>)students.stream().collect(Collectors.toMap(Student::getStudentId, student -> student));
      userTrailMap.forEach((userId, userTrailList) -> {
            StringBuilder builder = new StringBuilder();
            BullyingDetailDTO bullyingDetailDTO = new BullyingDetailDTO();
            bullyingDetailDTO.setCount(Integer.valueOf(userTrailList.size()));
            Date collectTime = userTrailList.stream().filter(()).sorted(Comparator.comparing(SourceUserTrail::getCollecttime).reversed()).findAny().map(SourceUserTrail::getCollecttime).orElse(null);
            if (collectTime != null)
              bullyingDetailDTO.setCollectTime(DateUtil.format(collectTime, "yyyy-MM-dd HH:mm:ss")); 
            Student student = (Student)studentMap.get(userId);
            if (student != null) {
              bullyingDetailDTO.setStudentId(student.getStudentId());
              bullyingDetailDTO.setStudentName(student.getStudentName());
              bullyingDetailDTO.setStudentPic(student.getStudentPic());
              bullyingDetailDTO.setClassId(student.getClassId());
              bullyingDetailDTO.setClassName(student.getClassName());
              bullyingDetailDTO.setGradeId(student.getGradeId());
              bullyingDetailDTO.setGradeName(student.getGradeName());
              Set<String> areaIds = (Set<String>)userTrailList.stream().map(SourceUserTrail::getAreaid).distinct().collect(Collectors.toSet());
              List<ThirdAreaDto> allBuilding = this.serviceUtils.getAllBuilding();
              List<ThirdAreaDto> collect = (List<ThirdAreaDto>)allBuilding.stream().filter(()).collect(Collectors.toList());
              String position = allBuilding.stream().filter(()).map(ThirdAreaDto::getBuildingName).collect(Collectors.joining("、"));
              bullyingDetailDTO.setPosition(position);
              Set<String> deviceIdsInSource = (Set<String>)userTrailList.stream().map(SourceUserTrail::getDeviceid).distinct().collect(Collectors.toSet());
              String bind_devices = setDeviceDeployments.stream().filter(()).map(SetDeviceDeployment::getDeviceName).collect(Collectors.joining("、"));
              builder.append(student.getStudentName()).append("出现在：").append(position).append("，轨迹来源：").append(bind_devices);
              bullyingDetailDTO.setDescription(builder.toString());
            } 
            ArrayList<BullyingDetailDTO.AbnormalMedia> abnormalMediaList = new ArrayList<>();
            String cameraUri = ObjFillUtils.getCalculateResourceAddress();
            List<String> picList = (List<String>)userTrailList.stream().map(SourceUserTrail::getActionPic).filter(Objects::nonNull).collect(Collectors.toList());
            if (!picList.isEmpty()) {
              String alarmRelatePic = this.serviceUtils.subLastNameToEnCode(picList.get(0));
              bullyingDetailDTO.setAlarmRelatePic(ObjFillUtils.concatenateStaticResourceUrls(cameraUri, alarmRelatePic));
              for (String pic : picList) {
                pic = this.serviceUtils.subLastNameToEnCode(pic);
                abnormalMediaList.add(new BullyingDetailDTO.AbnormalMedia(ObjFillUtils.concatenateStaticResourceUrls(cameraUri, pic), Integer.valueOf(1)));
              } 
            } 
            bullyingDetailDTO.setAbnormalMediaList(abnormalMediaList);
            finalBullyingDetailList.add(bullyingDetailDTO);
          });
      bullyingDetailList = (List<BullyingDetailDTO>)bullyingDetailList.stream().sorted(Comparator.comparingInt(BullyingDetailDTO::getCount).reversed()).collect(Collectors.toList());
      return PageUtil.startPage(bullyingDetailList, pageNum, pageSize);
    } catch (Exception e) {
      logger.error("获取欺凌异常详细信息失败，原因：", e);
      return PageUtil.startPage(null, pageNum, pageSize);
    } 
  }
}
